package me.Demon.DemonShop.gui;

import me.Demon.DemonCoins.util.CoinsAPI;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class ShopGui implements Listener {

    public static String buyItem_Lore = "§a§l✔§7SHIFT+左键点击购买§s§h§o§p";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().contains("§d§s§h§o§p§r")) {
            e.setCancelled(true);
            String key = e.getView().getTitle().replace("§d§s§h§o§p§r", "");
            if (e.getRawSlot() >= 0 && e.getRawSlot() < e.getInventory().getSize()) {
                ItemStack click_item = e.getCurrentItem();
                if (DemonAPI.itemIsNull(click_item)) {
                    return;
                }
                if (DemonAPI.itemIsLore(click_item)) {
                    return;
                }
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                int keySlot = e.getRawSlot();
                if (!Main.file_Name.contains(key)) {
                    return;
                }
                File file = new File("plugins/DemonShop/商店配置", key + ".yml");
                YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
                if (click_item.getType() == Material.BOOK) {
                    ItemMeta meta = click_item.getItemMeta();
                    if (meta.getDisplayName().contains("§a返回菜单")) {
                        String cmd = yml.getString("BackMenu.cmd");
                        Bukkit.dispatchCommand(Bukkit.getConsoleSender(), cmd.replace("%p%", p.getName()));
                        return;
                    }
                }
                String str = "DataShop." + keySlot + ".";
                String VaultType = yml.getString(str + "VaultType");
                int price = yml.getInt(str + "price");
                int amount = yml.getInt(str + "amount");
                ItemStack item = yml.getItemStack(str + "items").clone();
                item.setAmount(amount);
                boolean limit_butt = yml.getBoolean(str + "limit_butt");
                //获取商品剩余数量
                int limit_amount = yml.getInt("DataShop." + keySlot + ".limit_amount");
                if (limit_butt && e.getClick() == ClickType.SHIFT_RIGHT && p.isOp()) {
                    int limit_amount_max = yml.getInt("DataShop." + keySlot + ".limit_amount_max");
                    yml.set("DataShop." + keySlot + ".limit_amount", limit_amount_max);
                    Main.saveFileConfig(yml, file);
                    p.sendMessage(Main.prefix + "成功为商品补货!");
                    OpenGui(p, key, yml);
                    return;
                }
                if (e.getClick() == ClickType.SHIFT_LEFT) {
                    //检测该商品是否是限量购买
                    if (limit_butt) {
                        //获取商品剩余数量是否大于1
                        if (limit_amount <= 0) {
                            p.sendMessage(Main.prefix + "该商品已被其他玩家抢购一空...");
                            return;
                        }
                    }
                    if (VaultType.equalsIgnoreCase("points")) {
                        if (DemonAPI.hasPoints(p, price)) {
                            DemonAPI.takePoints(p, price);
                            if (yml.getString(str + "Command") != null) {
                                String commands = yml.getString(str + "Command").replace("%p%", p.getName());
                                Bukkit.dispatchCommand(Bukkit.getConsoleSender(), commands);
                            } else {
                                p.getInventory().addItem(item);
                            }
                            p.sendMessage(Main.prefix + "你花费了§d" + price + "点券§f购买了 " + item.getItemMeta().getDisplayName() + "§7§lx§f§l" + amount);
                            CheckLimitItems(p, limit_butt, keySlot, yml, file, limit_amount, key);
                            if (price >= 100) {
                                if (amount == 1) {
                                    Bukkit.broadcastMessage("§7[§6战争领域§7] §f玩家§6" + p.getName() + "§f在" + e.getView().getTitle() + "中购买了 " + item.getItemMeta().getDisplayName());
                                } else {
                                    Bukkit.broadcastMessage("§7[§6战争领域§7] §f玩家§6" + p.getName() + "§f在" + e.getView().getTitle() + "中购买了 " + item.getItemMeta().getDisplayName() + "§7§lx§f§l" + amount);
                                }
                            }
                        } else {
                            p.sendMessage(Main.prefix + "你需要§d" + price + "§f点券才能操作.");
                        }
                    } else if (VaultType.equalsIgnoreCase("money")) {
                        if (DemonAPI.hasMoney(p, price)) {
                            DemonAPI.takeMoney(p, price);
                            if (yml.getString(str + "Command") != null) {
                                String commands = yml.getString(str + "Command").replace("%p%", p.getName());
                                Bukkit.dispatchCommand(Bukkit.getConsoleSender(), commands);
                            } else {
                                p.getInventory().addItem(item);
                            }
                            p.sendMessage(Main.prefix + "你花费了§6" + price + "金币§f购买了 " + item.getItemMeta().getDisplayName() + "§7§lx§f§l" + amount);
                            CheckLimitItems(p, limit_butt, keySlot, yml, file, limit_amount, key);
                        } else {
                            p.sendMessage(Main.prefix + "你需要§6$" + price + "§f金币才能操作.");
                        }
                    } else if (VaultType.equalsIgnoreCase("coins")) {
                        if (CoinsAPI.getCoinsAmount(p.getName()) >= price) {
                            CoinsAPI.removeCoins(p.getName(), price);
                            if (yml.getString(str + "Command") != null) {
                                String commands = yml.getString(str + "Command").replace("%p%", p.getName());
                                Bukkit.dispatchCommand(Bukkit.getConsoleSender(), commands);
                            } else {
                                p.getInventory().addItem(item);
                            }
                            p.sendMessage(Main.prefix + "你花费了§b" + price + "软妹币§f购买了 " + item.getItemMeta().getDisplayName() + "§7§lx§f§l" + amount);
                            CheckLimitItems(p, limit_butt, keySlot, yml, file, limit_amount, key);
                            if (price >= 10) {
                                if (amount == 1) {
                                    Bukkit.broadcastMessage("§7[§6战争领域§7] §f玩家§6" + p.getName() + "§f在" + e.getView().getTitle() + "中购买了 " + item.getItemMeta().getDisplayName());
                                } else {
                                    Bukkit.broadcastMessage("§7[§6战争领域§7] §f玩家§6" + p.getName() + "§f在" + e.getView().getTitle() + "中购买了 " + item.getItemMeta().getDisplayName() + "§7§lx§f§l" + amount);
                                }
                            }
                        } else {
                            p.sendMessage(Main.prefix + "你需要§b" + price + "§f软妹币才能操作.");
                        }
                    }
                }

            }
        }
    }

    public static void takeShopAmount(int KeySlot, YamlConfiguration yml, File file, int limit_amount) {
        yml.set("DataShop." + KeySlot + ".limit_amount", (limit_amount - 1));
        Main.saveFileConfig(yml, file);
    }

    public static void CheckLimitItems(Player p, boolean limit_butt, int keySlot, YamlConfiguration yml, File file, int limit_amount, String key) {
        if (limit_butt) {
            takeShopAmount(keySlot, yml, file, limit_amount);
            OpenGui(p, key, yml);
        }
    }

    public static ItemStack getGlass_Pane(String name, int date) {
        ItemStack item = new ItemStack(160, 1, (short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }


    public static void OpenGui(Player p, String key, YamlConfiguration yml) {
        int Guisize = yml.getInt("Guisize");
        Inventory inv = Bukkit.createInventory(null, Guisize, "§d§s§h§o§p§r" + key);
        if (yml.getString("DataShop") != null) {
            String Type = yml.getString("Type");
            if (!Type.equalsIgnoreCase("money")) {
                for (int i = 0; i < inv.getSize(); i++) {
                    int date = (int) (Math.random() * 6.0D);
                    inv.setItem(i, getGlass_Pane("§r", date));
                }
            }
            if (yml.getString("BackMenu") != null) {
                int slot = yml.getInt("BackMenu.slot");
                inv.setItem(slot, BackMenu());
            }
            for (String keySlow : yml.getConfigurationSection("DataShop").getKeys(false)) {
                int slot = Integer.parseInt(keySlow);
                ItemStack item = yml.getItemStack("DataShop." + keySlow + ".items").clone();
                int amount = yml.getInt("DataShop." + keySlow + ".amount");
                int price = yml.getInt("DataShop." + keySlow + ".price");
                boolean limit_butt = yml.getBoolean("DataShop." + keySlow + ".limit_butt");
                String VaultType = yml.getString("DataShop." + keySlow + ".VaultType");
                if (limit_butt) {
                    int limit_amount = yml.getInt("DataShop." + keySlow + ".limit_amount");
                    int limit_amount_max = yml.getInt("DataShop." + keySlow + ".limit_amount_max");
                    inv.setItem(slot, ShopItems_limit(item, amount, price, limit_amount, limit_amount_max, VaultType));
                } else {
                    inv.setItem(slot, ShopItems_Nolimit(item, amount, price, VaultType));
                }
            }
        }
        p.openInventory(inv);
        p.playSound(p.getLocation(), Sound.BLOCK_CHEST_OPEN, 1, 1);
    }

    public static ItemStack ShopItems_limit(ItemStack items, int amount, int price, int limit_amount, int limit_amount_max, String VaultType) {
        ItemStack item = items.clone();
        item.setAmount(amount);
        item.setDurability(items.getDurability());
        ItemMeta meta = item.getItemMeta();
        List<String> lore = new ArrayList<>();
        if (VaultType.equalsIgnoreCase("points")) {
            lore.add("§7§l★§7单买价格: §d" + price + "点券");
        } else if (VaultType.equalsIgnoreCase("money")) {
            lore.add("§7§l★§7单买价格: §6" + price + "金币");
        } else if (VaultType.equalsIgnoreCase("coins")) {
            lore.add("§7§l★§7单买价格: §b" + price + "软妹币");
        }
        lore.add("§7§l★§7限量出售: §b" + limit_amount + " §7/ §b" + limit_amount_max);
        lore.add(buyItem_Lore);
        lore.add("§7-------------------------§b§u§y§r");
        lore.addAll(items.getItemMeta().getLore());
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack ShopItems_Nolimit(ItemStack items, int amount, int price, String VaultType) {
        ItemStack item = items.clone();
        item.setAmount(amount);
        item.setDurability(items.getDurability());
        ItemMeta meta = item.getItemMeta();
        List<String> lore = new ArrayList<>();
        if (VaultType.equalsIgnoreCase("points")) {
            lore.add("§7§l★§7单买价格: §d" + price + "点券");
        } else if (VaultType.equalsIgnoreCase("money")) {
            lore.add("§7§l★§7单买价格: §6" + price + "金币");
        } else if (VaultType.equalsIgnoreCase("coins")) {
            lore.add("§7§l★§7单买价格: §b" + price + "软妹币");
        }
        lore.add(buyItem_Lore);
        lore.add("§7-------------------------§b§u§y§r");
        lore.addAll(items.getItemMeta().getLore());
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack BackMenu() {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§a返回菜单");
        List<String> lore = new ArrayList<>();
        lore.add("§7§l★§7返回商城菜单");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
