package me.Demon.DemonShop.gui;

import me.Demon.DemonShop.Main;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.io.File;

public class CreateGui implements Listener {

    public static void OpenGui(Player p, String key, YamlConfiguration yml) {
        Inventory inv = Bukkit.createInventory(null, 54, "§1§2§3§r正在设置商店: " + key);
        if (yml.getString("DataShop") != null) {
            for (String keySlow : yml.getConfigurationSection("DataShop").getKeys(false)) {
                int slot = Integer.parseInt(keySlow);
                ItemStack item = yml.getItemStack("DataShop." + keySlow + ".items").clone();
                inv.setItem(slot, item);
            }
        }
        p.openInventory(inv);
    }

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().contains("§1§2§3§r正在设置商店: ")) {
            e.setCancelled(true);
            String key = e.getView().getTitle().replace("§1§2§3§r正在设置商店: ", "");
            if (e.getRawSlot() >= 0 && e.getRawSlot() <= 54) {
                File file = Main.getFilePath(key);
                if (file != null) {
                    YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
                    if (Main.hashPrice.get(p) == null) {
                        p.closeInventory();
                        return;
                    }
                    int price = Main.hashPrice.get(p);
                    int amount = Main.hashAmount.get(p);
                    ItemStack item = Main.hashItems.get(p);
                    item.setAmount(1);
                    yml.set("DataShop." + e.getRawSlot() + ".VaultType", "Points");
                    yml.set("DataShop." + e.getRawSlot() + ".price", price);
                    yml.set("DataShop." + e.getRawSlot() + ".amount", amount);
                    yml.set("DataShop." + e.getRawSlot() + ".items", item);
                    Main.saveFileConfig(yml, file);
                    RemoveHash();
                    p.sendMessage("设置成功 " + key);
                    OpenGui(p, key, yml);
                }
            }
        }
    }

    public static void RemoveHash() {
        Main.hashPrice.clear();
        Main.hashAmount.clear();
        Main.hashItems.clear();
    }
}